/*##############################################################################################*
*###############################################################################################*
*                                                                                               *
*                                               AUX.C	                                        *
*                                       MpTcp's Source file	                                *
*                                                                                               *
*                                              -- ## --                                         *
*                                          MpTcp Ver: 1.6	                                *
*                            	  (This file is part of MpTcp tool)			        *
*                                       Date: 10/02/2010 (09:15)                                *
*                                                                                               *
*                                                                                               *
*                       .......................................................                 *
*                                                                                               *
*                                Felipe de Oliveira - khun@hexcodes.org                         *
*                                                                                               *
*                                                                                               *
###############################################################################################*/

#include "include/tcpip.h"
#include "include/utils.h"
#include "include/socks.h"
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <netpacket/packet.h>
#include <linux/sockios.h>
#include <linux/if.h>
#include <termios.h>

// Macros...
#define		MSG_ECHO	"ICMP Type 8 (Echo Request)"
#define 	MSG_REPLY	"ICMP Type 0 (Echo Reply)"
#define 	MSG_MASK	"ICMP Type 17 (Mask Request)"
#define 	MSG_MREPLY	"ICMP Type 18 (Mask Reply)"
#define 	MSG_TTL		"ICMP Type 11 (TTL Excedded)"
#define 	MSG_INAT	"ICMP Type 3 (Dest. Unreacheable)"
#define 	MSG_QUENCH	"ICMP Type 4 (Source Quench)"
#define 	MSG_TSTAMPRQ	"ICMP Type 13 (Timestamp Request)"
#define 	MSG_TSTAMPRP	"ICMP Type 14 (Timestamp Reply)"
#define 	MSG_TRACER	"ICMP Type 30 (Traceroute)"

// Secao Globais......
extern 	time_t	tpo;
extern 	struct	tm *mto;
extern	UINT	IX;
extern	UINT	SP;
extern 	UINT	RQ;	
extern	UINT	ARPING;	
extern	UINT	MACFLD;	
extern	UINT	RARP;	
extern	UINT	NI; 	
extern 	UINT	TU;		
extern 	UINT	M;  	
extern 	UINT	SR; 	
extern 	UINT	DS; 	
extern 	UINT	DL; 	
extern 	UINT	LU; 	
extern 	UINT	LT; 	
extern 	UINT	LE; 	
extern	UINT	CON;	
extern 	int	syn;		
extern 	int	ack;		
extern 	int	fin;		
extern 	int	rst;		
extern 	UINT	udp;	
extern 	UINT	cont;	
extern 	int	psh;		
extern 	int	urg;		
extern 	int	null;		
extern 	UINT	flagport;
extern 	UINT	proto;	
extern 	UINT	X;	
extern 	int	io;		
extern	UINT	flood;	
UCHAR	*msg; 			
char	ETH[13];		
UCHAR	randip[16];		



// ####################################### Global CheckSum ##########################################

u_short in_cksum(u_short *addr, int len)
{
    register int nleft  = len;
    register u_short *w = addr;
    register int sum    = 0;
    u_short answer      = 0;

    while (nleft > 1)  
    {
        sum   += *w++;
        nleft -= 2;
    }
    if (nleft == 1) 
    {
        *(u_char *)(&answer) = *(u_char *)w ;
        sum += answer;
    }
    sum    = (sum >> 16) + (sum & 0xffff);
    sum   += (sum >> 16);
    answer = ~sum;
    return(answer);
}

// ######################################## ramdom_ip() #######################################
UCHAR *random_ip (void)
{

        unsigned char a, b, x, y;

	memset(randip, 0, sizeof(randip));
        a= rand() % 0xfe;
        b= rand() % 0xfe;
        x= rand() % 0xfe;
        y= rand() % 0xfe;

        sprintf((char *)randip, "%d.%d.%d.%d", a, b, x, y);
	return randip;
}

// ######################################## ramdom_mac() #######################################
void random_mac (void)
{

        unsigned char a, b, c, x, y, z;

        memset(ETH, 0, sizeof(ETH));
        a= rand() % 0xfe;
        b= rand() % 0xfe;
	c= rand() % 0xfe;
        x= rand() % 0xfe;
        y= rand() % 0xfe;
	z= rand() % 0xfe;

        sprintf(ETH, "%x%x%x%x%x%x", a, b, c, x, y, z);
}


// ######################################## fe_getch() ##################################################
int fe_getch(void)
{
        struct termios oldt, newt;
        int ch;

        tcgetattr( STDIN_FILENO, &oldt );
        newt = oldt;
        newt.c_lflag &= ~( ICANON | ECHO );
        tcsetattr( STDIN_FILENO, TCSANOW, &newt );
        ch = getchar();
        tcsetattr( STDIN_FILENO, TCSANOW, &oldt );

        return ch;
}


// ######################################## meu_ip() ##################################################

UCHAR *meu_ip(const char *placa)
{
  int meu_sock, i, j;
  struct ifreq eth;
  UCHAR *ip;
  char mac[32];

  meu_sock = socket(AF_INET, SOCK_DGRAM, 0);
  eth.ifr_addr.sa_family = AF_INET;
  strncpy(eth.ifr_name, placa, IFNAMSIZ-1);
  io	= ioctl(meu_sock, SIOCGIFADDR, &eth);
  ip= (UCHAR *) inet_ntoa(((struct sockaddr_in *)&eth.ifr_addr)->sin_addr);
  ioctl(meu_sock, SIOCGIFHWADDR, &eth);
  for (i= 0, j= 0; i < 6; i++) 
  {
        j+=snprintf(mac + j, sizeof(mac) -j -1, i ? "%02X" : "%02X", (int)(unsigned int)(unsigned char)eth.ifr_hwaddr.sa_data[i]);
  }
  mac[sizeof(mac)-1]='\0';
  snprintf(ETH, 13, "%s", mac);
  close(meu_sock);
  return ip;
} 


// #####################################################################################################
//					   ICMP()
// #####################################################################################################

int modoicmp (UCHAR *origem, UCHAR *destino, int tipo, UCHAR *net, UCHAR *pct, int ttl)
{
	  unsigned char dados[IX+30], recvbuff[IX+30], *msg;
	  struct icmphdr *icmp;
	  struct iphdr *ip;
	  struct sockaddr_in home, alvo, remoto;
	  struct pseudo *param;
	  struct hostent *host;
	  struct timeval times;
	  fd_set redfs;
	  int mysock, sockicmp, E, i, num, sel, setsock= 1;
	  unsigned int tamrem;

  mysock= socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  sockicmp= socket(AF_INET, SOCK_RAW, 1);
  if (mysock < 0) 
  { 
	perror("\nError on Socket create IPPROTO_RAW !!\n");  
	exit(ERR); 
  }
  if (sockicmp < 0) 
  { 
	perror("\nErro on Socket create IPPROTO_ICMP !!\n");  
	exit(ERR); 
  }


//  ......................................... Listen MODE Icmp............................................

  if (tipo == 0xFF)  
  {
   memset(recvbuff,0,sizeof(recvbuff));
   ip= (struct iphdr *) recvbuff;
   icmp= (struct icmphdr *) (recvbuff + sizeof(struct iphdr));
   param= (struct pseudo *)(recvbuff + sizeof(struct iphdr) + sizeof(struct icmphdr));

   fprintf(stderr,"\n%s\n", pct);
   tamrem = sizeof(remoto);
   for (;;)
   { 
	num= recvfrom(sockicmp, recvbuff, sizeof(recvbuff), 0, (struct sockaddr *) &remoto, &tamrem);
	if (num < 0) 
	{ 
		close(sockicmp); close(mysock); 
		return -1; 
	}
        switch(icmp->type)
	{
	case 0x08:
		{
		msg= (unsigned char *) MSG_ECHO;
		break; 
		}
	case 0x00 : 
		{
		msg= (unsigned char *) MSG_REPLY;
		break; 
		}
	case 0x04:
		{
		msg= (unsigned char *) MSG_QUENCH;
		break;
		}
	case 0x11: 
		{
		msg= (unsigned char *) MSG_MASK;
		break; 
		}
	case 0x12: {
		msg= (unsigned char *) MSG_MREPLY;
		break; }
	case 0x0B: {
		msg= (unsigned char *) MSG_TTL;
		break; }
	case 0x03: {
		msg= (unsigned char *) MSG_INAT;
	        break; }
	case 0x0D: {
		msg= (unsigned char *) MSG_TSTAMPRQ;
		break;}
	case 0x0E: {
		msg= (unsigned char *) MSG_TSTAMPRP;
		break; }
	case 0x1E: {
		msg= (unsigned char *) MSG_TRACER;
		break; }
	default: {
		msg= (unsigned char *) "Unknown ICMP data types"; }
	}			
	time(&tpo);  mto=localtime(&tpo);
	fprintf(stderr,"[%d] - (%02d:%02d) Received packet %s from (%s) with %d bytes - TTL[%d]\n", X++, mto->tm_hour, mto->tm_min, msg, inet_ntoa(remoto.sin_addr),  num, ip->ttl);
	if (icmp->type == 0x12)
		fprintf(stderr," - Mask [%s]\n\n", inet_ntoa(param->tetrab1));   
     }
  } 
// .............................   Fim de listem ICMP   .........................................

  setsockopt(mysock, SOL_SOCKET, SO_BROADCAST, (char *) &setsock, sizeof(setsock));
  alvo.sin_family= AF_INET;
  if ((host= (struct hostent *) gethostbyname((char *)destino)) == NULL)
  { 
	herror("Error on Destination Hostname"); 
	exit(ERR); 
  } 
  bcopy(host->h_addr_list[0], &(alvo.sin_addr.s_addr),host->h_length); 
  for (i= 0; i < 8; i++)
          alvo.sin_zero[i]= '\0';
  
  home.sin_family= AF_INET;
  if (origem == NULL) home.sin_addr.s_addr= INADDR_ANY;
  else 
  { 
	if ((host= (struct hostent *) gethostbyname((char *) origem)) == NULL)
	{
		herror("Error on Source Hostname"); 
		exit(ERR); 
	}
	bcopy(host->h_addr_list[0], &(home.sin_addr.s_addr), host->h_length);
  }  	
  for (i= 0; i < 8; i++)
          home.sin_zero[i]= '\0';

  memset(dados,0,sizeof(dados));  
  ip= (struct iphdr *) dados; 
  icmp= (struct icmphdr *) (dados + sizeof(struct iphdr)); 
  param= (struct pseudo *) (dados + sizeof(struct iphdr) + sizeof(struct icmphdr));
  
     memset(dados,0,sizeof(struct iphdr));
     ip->saddr = home.sin_addr.s_addr;
     ip->daddr = alvo.sin_addr.s_addr;
     ip->version = 4;
     ip->frag_off= 0; //htons(IP_MF);
     ip->ihl = 5;
     ip->ttl = ttl;
     ip->id = rand() % 0xffff;
     ip->protocol = 1; 
     ip->tot_len = htons(21);
     ip->check = in_cksum((u_short *)ip, sizeof(struct iphdr));
     
	icmp->type             		=  tipo;
	icmp->code             		=  0;
	icmp->checksum	         	=  0;
	icmp->un.echo.id     		=  0x05;
	icmp->un.echo.sequence  	=  0x07;
	icmp->checksum =  in_cksum((u_short *)icmp, sizeof(struct icmphdr) + sizeof(struct pseudo));
  
  if (tipo == 0x12)
	param->tetrab1.s_addr = inet_addr((char *)net);

  if (SP)
  {
	fprintf(stderr,"[Flooding] Sending ICMP packets type %d (%s) to Host [%s]...\n", tipo, pct, inet_ntoa(alvo.sin_addr));
	for (; ;)
		sendto(mysock, dados, sizeof(dados), 0,(struct sockaddr *) &alvo, sizeof(alvo));
  }
  do
  {
     fprintf(stderr,"[%d] - Sending ICMP packet type %d (%s) - Host [%s]...\n", X++, tipo, pct, inet_ntoa(alvo.sin_addr));
     E= sendto(mysock, dados, sizeof(dados), 0,(struct sockaddr *) &alvo, sizeof(alvo));
     if (E == ERR) 
     { 
	  close(mysock); close(sockicmp);
 	  return -1;
     }
     if (!NI)
     {
	if ((tipo == 0x08) || (tipo == 0x11))
	{
		times.tv_sec= 4;
		times.tv_usec= 0;
		FD_ZERO(&redfs);
		FD_SET(sockicmp, &redfs);
		sel= select(sockicmp + 1, &redfs, NULL, NULL, &times);
	       	if (sel == 0)
		{
			fprintf(stderr,"TimeOut...\n\n");
			return -1;
		}
		memset(recvbuff,0,sizeof(recvbuff));
		ip= (struct iphdr *) recvbuff;
		icmp= (struct icmphdr *) (recvbuff + sizeof(struct iphdr));
		param= (struct pseudo *)(recvbuff + sizeof(struct iphdr) + sizeof(struct icmphdr));
		tamrem = sizeof(remoto);
	        do
		{	
			num= recvfrom(sockicmp, recvbuff, sizeof(recvbuff), 0, (struct sockaddr *) &remoto, &tamrem);	
			if (num == ERR) 
				return -1;
		} while(alvo.sin_addr.s_addr != remoto.sin_addr.s_addr);	
		fprintf(stderr,"Host [%s] responds with Echo Reply - %d Bytes - TTL [%d]\n\n", inet_ntoa(remoto.sin_addr), \
		num, ip->ttl);
		if (tipo == 0x11)
    	 	fprintf(stderr,"MASK is ==> [%s] \n\n", inet_ntoa(param->tetrab1));
	}
     }
     if (cont)
	sleep(1);
     else if (DL) 
	usleep(DL);

  } while ((cont) || (DL));
  close(sockicmp);
  close(mysock);
  return 0;
}


// #######################################################################################################
//                                          TCP()
// #######################################################################################################

int modotcp(UCHAR *origem, UCHAR *destino, UCHAR *msg, int porta, int sporta, int syn, int ack, int fin, int rst, int psh, int urg, int ttl)
{

#define TAM 256 

   unsigned char dados[40], *end_ip, buff[2048], buffer[TAM],*flag;
   struct tcphdr *tcp;
   struct iphdr *ip;
   struct sockaddr_in home, alvo, remoto;
   struct hostent *host;
   struct timeval times;
   int mysock, socktcp, socklisten, nsock, E, i;
   int num, sel, q, conector;
   unsigned int tamrem;
   fd_set redfs;
   char c;
   struct pseudohdr {
	   u_int32_t saddr;
	   u_int32_t daddr;
	   u_int8_t useless;
	   u_int8_t protocol;
	   u_int16_t tcptam;
	   struct tcphdr tcp;
   } ps;
    
   mysock= socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
   socktcp= socket(AF_INET, SOCK_RAW, IPPROTO_TCP);
   socklisten= socket(AF_INET, SOCK_STREAM, 0);
   if (mysock < 0) 
   { 
	perror("\nError on Socket create IPPROTO RAW\n"); 
	exit(ERR);
   }
   if (socktcp < 0) 
   { 
	perror("\nError on Socket create SockTCP\n"); 
	exit(ERR);
   }
   if (socklisten < 0) 
   { 
	perror("\nError on Socket create SockListen TCP\n"); 
	exit(ERR);
   }
   q= 1;
   if (setsockopt(socktcp, IPPROTO_IP, IP_HDRINCL, &q, sizeof(q)) == -1)
   { 
	perror("\nError on SetSockOpt-TCP(): \n"); 
	exit(ERR); 
   }
   
   if (!(destino == NULL))
   {
	if ((host= (struct hostent *)gethostbyname((char *)destino)) == NULL)
	{ 
		herror("Error on Destination Hostname"); 
		exit(ERR); 
	} 
	bcopy(host->h_addr_list[0], &(alvo.sin_addr.s_addr),host->h_length);
	alvo.sin_port= htons(porta);
	for (i= 0; i < 8; i++)
		alvo.sin_zero[i]= '\0';
	alvo.sin_family= AF_INET;
   }
   if (LT) home.sin_port= htons(porta);
   else if (sporta) home.sin_port= htons(sporta);
   else home.sin_port= htons(rand() % 65535);
   home.sin_family= AF_INET;
   if (origem == NULL) 
   {
	if (LT) 
		home.sin_addr.s_addr= INADDR_ANY;
	else
	{
		end_ip= meu_ip("eth0");
		if (!(io)) 
		{ 
			home.sin_addr.s_addr= inet_addr((char *)end_ip); 
			goto P; 
		}
        	end_ip= meu_ip("eth1");
		if (!(io)) 
		{ 
			home.sin_addr.s_addr= inet_addr((char *)end_ip); 
			goto P; 
		}
		end_ip= meu_ip("eth2");
		if (!(io)) 
		{ 
			home.sin_addr.s_addr= inet_addr((char *)end_ip); 
			goto P; 
		}
		end_ip= meu_ip("eth3");
		if (!(io)) 
		{ 
			home.sin_addr.s_addr= inet_addr((char *)end_ip); 
			goto P; 
		}
		end_ip= meu_ip("eth4");
		if (!(io)) 
		{ 
			home.sin_addr.s_addr= inet_addr((char *)end_ip); 
			goto P; 
		}
		fprintf(stderr,"\nNo interfaces found. Use -s <Source Ip>\n");
		close(mysock); 
		close(socktcp); 
		close(socklisten); 
		exit(ERR);   
   	}
   }
   else
   {
	if ((host= (struct hostent *)gethostbyname((char *)origem)) == NULL)
	{
		herror("Error on Source Hostname"); 
		exit(ERR); 
	}
	bcopy(host->h_addr_list[0], &(home.sin_addr.s_addr),host->h_length);
   }
P: 
   for (i= 0; i < 8; i++)
	home.sin_zero[i]= '\0';

// ..................................... Listen MODE Tcp ............................................

   if (LT)
   {
	if (bind(socklisten, (struct sockaddr *) &home, sizeof(struct sockaddr)) < 0)
	{
          	perror("\nError on Bind(): \n");
        	close(mysock); close(socktcp); close(socklisten); 
		exit(ERR); 
	}
	if (listen(socklisten, NUMCONEC) < 0)
        { 
		perror("Error on Listen: ");
		close(mysock); close(socktcp); close(socklisten); 
		exit(ERR); 
	}

#define REMOTO remoto.sin_addr.s_addr      

      tamrem= sizeof(remoto);
      fprintf(stderr,"TCP listening on Port [%d]:\n", porta);
      for(;;)
      {
	if((nsock= accept(socklisten, (struct sockaddr *) &remoto, &tamrem)) <= 0)
	{
	 	perror("\nErro on Accept: \n");
       		close(mysock); close(socktcp); close(socklisten); 
		exit(ERR);
	}		
	if (!fork())
	{
		time(&tpo);   mto= localtime(&tpo);

#define MSG "\nMpTcp says: [Connected] \nSniffing data:\n\n"

       		if(write(nsock, MSG, strlen(MSG)) < 0)
	      		perror("\nError on Write(): \n");
       		fprintf(stderr,"(%d:%d) - Connected: Open by Host [%s]\n", mto->tm_hour, mto->tm_min, inet_ntoa(remoto.sin_addr));
		for(;;)
		{
			memset(buffer, 0, TAM);
	  		time(&tpo);   mto= localtime(&tpo);
			i= read(nsock, buffer, sizeof(buffer));
	  		if (i < 0)
	  		{  
					perror("\nError on Read()\n"); 
					exit(ERR); 
			}
			fprintf(stdout,"[%d:%d] - Host (%s) says: %s\n", mto->tm_hour, mto->tm_min, inet_ntoa(remoto.sin_addr), buffer);
		}
	}
	close(nsock);
	while(waitpid(-1, NULL, WNOHANG) < 0);
      } 
   }   
 	// ..................................... Fim Listem Modo TCP..............................................

	// .......................................................................................................

   if (CON)
   {
     if(SP)
     {
	fprintf(stderr,"(Flooding] Doing connections to Host [%s] on port [%d]...\n", destino, porta);
	for(; ;)
	        conector= connect(socklisten,(struct sockaddr *) &alvo, sizeof(struct sockaddr));
     }
     else
     {
        conector= connect(socklisten,(struct sockaddr *) &alvo, sizeof(struct sockaddr));
        if (conector == -1)
        {
                fprintf(stderr,"\nUnable to connect on Host (%s) : port(%d).\n\n", destino, porta);
                exit(1);
        }
        time(&tpo); mto= localtime(&tpo);
        fprintf(stderr,"(%d:%d) Connected on Host [%s] : Port [%d]:\n\n", mto->tm_hour, mto->tm_min, destino, porta);
	memset(&buffer, 0, sizeof(buffer));
	read(socklisten, &buffer, TAM);
	printf("%s", buffer);
	for (; ;)
	{
		c = fe_getch();
		printf("%c", c);
		write(socklisten, &c, 1);		
	}
     }
   }
	// ........................................................................................................

   memset(dados, 0, 40);
   ip= (struct iphdr *) dados;
   tcp= (struct tcphdr *) (dados + T_IP);
       
       memset(dados,0,sizeof(struct iphdr));
       ip->saddr = home.sin_addr.s_addr;
       ip->daddr = alvo.sin_addr.s_addr;
       ip->version = 4;
       ip->ihl = 5;
       ip->ttl = ttl;
       ip->id = rand() % 0xFFFF;  
       ip->protocol = IPPROTO_TCP;
       ip->tot_len = htons(sizeof(struct iphdr) + sizeof(struct tcphdr));
       ip->check = 0; 

	tcp->source	= home.sin_port;
	tcp->dest	= alvo.sin_port;
	tcp->seq	= rand() % 0xFFFFFFFF;
	tcp->ack_seq	= 0;
	tcp->res1	= 0;
	tcp->doff	= 5;
	tcp->res2	= 0;
	tcp->fin	= fin; 
	tcp->syn	= syn;
	tcp->rst	= rst;
	tcp->psh	= psh;
	tcp->ack	= ack;
	tcp->urg	= urg;
	tcp->window	= htons(512);
	tcp->check	= 0;
	tcp->urg_ptr	= 0;

        ps.saddr        = ip->saddr; 
        ps.daddr        = ip->daddr; 
        ps.useless      = 0;
        ps.protocol     = IPPROTO_TCP;   
        ps.tcptam       = htons(20);     
        bcopy(tcp, &ps.tcp, 20);         
	tcp->check= in_cksum((u_short *)&ps, 32);

  if (SP)
  {
	fprintf(stderr,"[Flooding] Sending %s packets to Host [%s] on Port [%d]...\n", msg, inet_ntoa(alvo.sin_addr), porta);
	for (; ;)
		sendto(mysock, dados, sizeof(dados), 0,(struct sockaddr *) &alvo, sizeof(alvo));
  }	
  do
  {	
	time(&tpo); mto= localtime(&tpo); 
	fprintf(stderr,"[%d] - (%d:%d) Sending %s packet to Host [%s] on Port [%d]...\n", X++, mto->tm_hour, mto->tm_min, \
	msg, inet_ntoa(alvo.sin_addr), porta);
	E= sendto(mysock, dados, sizeof(dados), 0,(struct sockaddr *) &alvo, sizeof(alvo));
	if (E == ERR) 
	{
		close(mysock); close(socktcp); close(socklisten); 
		exit(ERR);
	}
	if (!NI)
	{
		times.tv_sec= 15; 
		times.tv_usec= 0;
		FD_ZERO(&redfs);
		FD_SET(socktcp, &redfs);
		sel= select(socktcp + 1, &redfs, NULL, NULL, &times);
		if (sel == 0)
		{
			fprintf(stderr,"Timeout...\n\n");
			close(mysock); close(socktcp); close(socklisten); 
			exit(ERR); 
		}
		memset(buff,0,2048);
		ip= (struct iphdr *) buff;
		tcp= (struct tcphdr *) (buff + sizeof(struct iphdr));

		tamrem = sizeof(remoto);
		do
		{
			num= recvfrom(socktcp, buff, sizeof(buff), 0, (struct sockaddr *) &remoto, &tamrem); 
			if (num < 0) 
				return -1; 
		} while (alvo.sin_addr.s_addr != remoto.sin_addr.s_addr);
		if (tcp->rst) 
			flag= (unsigned char *) "RST";
		else if (tcp->ack)
			flag= (unsigned char *) "ACK";
		else if (tcp->fin)
			flag= (unsigned char *) "FIN";
		else if (tcp->psh)
			flag= (unsigned char *) "PSH";
		else 
			flag= (unsigned char *) "NoFLAG";   
		fprintf(stderr,"Host [%s] responds with %d Bytes: TTL [%d] - WIN [%d] - Flag [%s]\n\n", inet_ntoa(remoto.sin_addr), \
		num, ip->ttl, tcp->window, flag);
	}
	if (cont)
		sleep(1);
	else if (DL) 
		usleep(DL);
  } while ((cont) || (DL));
  close(socktcp);
  close(mysock);
  close(socklisten);
  return 0;
}


// #######################################################################################################
//                                          ROTINA   UDP()
// #######################################################################################################

int modoudp(UCHAR *origem, UCHAR *destino, UCHAR *msg, int porta, int sporta, int tam, int ttl)
{
	struct sockaddr_in alvo, home, remoto;
	struct iphdr *ip;
	struct udphdr *udp;
	struct icmphdr *icmp;
	struct timeval times;
	struct hostent *host;
	UCHAR pacote[tam+28], buff[1024], recvbuff[40]; 
	UCHAR *dados;
	UCHAR data[tam];
	fd_set redfs;
	int mysock, sockudp, sockicmp, i, E, sel, num;
	unsigned int tamrem;

    mysock= socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
    sockudp= socket(AF_INET, SOCK_DGRAM, 0);
    sockicmp= socket(AF_INET, SOCK_RAW, 1);
    if (mysock < 0) 
    { 
	perror("\nError on Socket create IPPROTO RAW\n"); 
	exit(ERR);
    } 
    if (sockudp < 0) 
    { 
	perror("\nError on Socket create Listen UDP\n"); 
	exit(ERR);
    }
    if (sockicmp < 0) 
    { 
	perror("\nError on Socket create ICMP\n"); 
	exit(ERR);
    }  
    if (!(destino == NULL))
    {
	if ((host= (struct hostent *)gethostbyname((char *)destino)) == NULL)
	{ 
		herror("Error on Destination Host"); 
		exit(ERR); 
	}
	bcopy(host->h_addr_list[0], &(alvo.sin_addr.s_addr),host->h_length);
        alvo.sin_port= htons(porta);
        for (i= 0; i < 8; i++)
            alvo.sin_zero[i]= '\0';
	alvo.sin_family= AF_INET;
    }
    if (LU) 
	home.sin_port= htons(porta);
    else if (sporta) 
	home.sin_port= htons(sporta);
    else 
	home.sin_port= htons(rand() % 65535);
    home.sin_family= AF_INET;
    if (origem == NULL) 
	home.sin_addr.s_addr= INADDR_ANY;
    else 
    {
	if ((host= (struct hostent *) gethostbyname((char *)origem)) == NULL)
	{
		herror("Error on Source Hostname"); 
		exit(ERR); 
	}
	bcopy(host->h_addr_list[0], &(home.sin_addr.s_addr), host->h_length);
    }
    for (i= 0; i < 8; i++)
          home.sin_zero[i]= '\0';

// ......................................   Listen MODE UDP  ............................................

    if (LU)
    {
    	if (bind(sockudp, (struct sockaddr *) &home, sizeof(struct sockaddr)) < 0)
	{
	    perror("\nError on Bind(): \n"); 
	    close(mysock); close(sockudp); 
	    exit(ERR); 
	}
    
    	tamrem= sizeof(remoto);
	fprintf(stderr,"UDP listening on Port [%d]:\n", porta);
    	for(;;)
    	{	    
		memset(buff , 0, 1024);
		num= recvfrom(sockudp, buff, sizeof(buff), 0, (struct sockaddr *) &remoto, &tamrem);
		time(&tpo);   
		mto= localtime(&tpo);
		printf("[%d:%d] - Host (%s) says: %s\n", mto->tm_hour, mto->tm_min, inet_ntoa(remoto.sin_addr), buff);
	}
    }  

//   .....................................   Fim Modo Listen UDP  .......................................

    memset(pacote,0,sizeof(pacote));     
    ip= (struct iphdr *) pacote; 
    udp= (struct udphdr *) (pacote + T_IP);  
    dados= (unsigned char *)(pacote + T_IP + T_UDP);
    memset(data,'X',tam);
    memcpy(dados, data ,tam);
    
    memset(pacote,0,sizeof(struct iphdr));
    ip->saddr = home.sin_addr.s_addr;
    ip->daddr = alvo.sin_addr.s_addr;
    ip->version = 4;
    ip->ihl = 5;
    ip->ttl = ttl;
    ip->id = rand() % 0xffff;
    ip->protocol = 17;
    ip->tot_len = htons(sizeof(struct iphdr) + sizeof(struct udphdr) + sizeof(dados));
    ip->check = in_cksum((u_short *)ip, sizeof(struct iphdr));

    	udp->source= home.sin_port;
	udp->dest= alvo.sin_port;
	udp->len= htons(T_UDP + sizeof(dados));
	udp->check = 0;

  if (SP)
  {
	fprintf(stderr,"[Flooding] Sending %s packets to Host [%s] on port [%d]...\n", msg, destino, porta);
	for (; ;)
		sendto(mysock, pacote, sizeof(pacote), 0,(struct sockaddr *) &alvo, sizeof(alvo));
  }
  do
  {	
	fprintf(stderr,"[%d] - Sending %s packet to Host [%s] on port %d...\n", X++, msg, destino, porta);
	E= sendto(mysock, pacote, sizeof(pacote), 0,(struct sockaddr *) &alvo, sizeof(alvo));
	if (E == ERR) 
	{
		close(mysock); close(sockudp); 
		return -1;
	}	
	if (!NI)
	{
		times.tv_sec= 5;  //timeout 5 seconds...
	   	times.tv_usec= 0; // Microseconds...
	   	FD_ZERO(&redfs);
	   	FD_SET(sockicmp, &redfs);
	   	sel= select(sockicmp + 1, &redfs, NULL, NULL, &times);
	   	if (sel == 0)
	      		return 0;
	   	memset(recvbuff,0,40);
	   	ip= (struct iphdr *) recvbuff;
	   	icmp= (struct icmphdr *) (recvbuff + sizeof(struct iphdr));

   		tamrem = sizeof(remoto);
		do
		{ 
			num= recvfrom(sockicmp, recvbuff, sizeof(recvbuff), 0, (struct sockaddr *) &remoto, &tamrem);  if (num < 0) return 0;
		} while (remoto.sin_addr.s_addr != alvo.sin_addr.s_addr);
		time(&tpo); 
		mto= localtime(&tpo);
		if (icmp->code == 0) 
			dados= (unsigned char *) "Net Unreachable";
	   	else if(icmp->code == 1) 
			dados= (unsigned char *) "Host Unreachable";
	   	else if(icmp->code == 2) 
			dados= (unsigned char *) "Protocolo Unreachable";
	   	else if(icmp->code == 3) 
			dados= (unsigned char *) "Porta Unreachable";
	   	else if(icmp->code == 9) 
			dados= (unsigned char *) "Network is Administratively Prohibited";
	   	else if(icmp->code == 10) 
			dados= (unsigned char *) "Host is Administratively Prohibited";
	   	else 
			dados= (unsigned char *) "Error on data send";
		fprintf(stderr,"Host [%s] sent ICMP response with %d Bytes - TTL [%d]: (%s)\n\n", inet_ntoa(remoto.sin_addr),  num, ip->ttl, dados);
	}	
	if (cont)
		sleep(1);
	else if (DL) 
		usleep(DL);
  } while ((cont) || (DL));
  close (mysock); 
  close(sockudp); 
  close(sockicmp);
  return 0;
}



// #######################################################################################################
//                                       ROTINA    ARP - RARP ()
// #######################################################################################################


// #########################################   CRIA PACOTE ()   ##########################################

void *cria_pacote(struct mac_address *macsrc, struct mac_address *macdst, char *ipsrc, char *ipdst)
{
    char *pacote = (char *)malloc(60);
    struct hostent *host;
    struct sockaddr_in alvo, home;
    int x, arp= 0;
    memset(pacote, 0, 60);

    for(x=0; x<=6; x++)
	if(RARP && RQ)
		pacote[x] = 0xFF;
	else
		pacote[x] = *((char *)macdst+x);
    for(x=0; x<=6; x++) 
        pacote[6+x] = *((char *)macsrc+x);
    
    if(RARP)
	*(unsigned short *)(pacote + 12) = (unsigned short)htons(0x8035);
    else
	*(unsigned short *)(pacote + 12) = (unsigned short)htons(0x0806);
    *(unsigned short *)(pacote + 14) = (unsigned short)htons(1); 
    *(unsigned short *)(pacote + 16) = (unsigned short)htons(0x0800);
    *(unsigned char *)(pacote + 18) = 6; 
    *(unsigned char *)(pacote + 19) = 4; 

    if (RARP)
    {
        if (RQ)    
        {
                arp += 3;
                msg= (unsigned char *) "RARP Request";
        }
        else 
        {
                arp += 4;
                msg= (unsigned char *) "RARP Reply";
        }
    }
    else
    {
	if (RQ) 
	{ 
		arp++; 
		msg= (unsigned char *) "ARP Request"; 
	}
    	else
	{
		arp += 2;
		msg= (unsigned char *) "ARP Reply";
	}
    }

    *(unsigned short *)(pacote + 20) = (unsigned short)htons(arp); 
	    
    for(x= 0; x<= 6; x++) 
        pacote[22 + x] = *((char *)macsrc+x); 

    if ((host= gethostbyname(ipsrc)) == NULL)
    { 
		herror("Error on Source Hostname\n"); 
		exit(ERR); 
    }
    bcopy(host->h_addr_list[0], &(home.sin_addr.s_addr),host->h_length);
    *(unsigned long *)(pacote + 28) = home.sin_addr.s_addr; 

    for(x=0; x<=6; x++)
	pacote[32 + x] = *((char *) macdst+x );
    
    if (!(ipdst == NULL))
    { 
	if ((host= gethostbyname(ipdst)) == NULL)
	{ 
		herror("Error on Destination Hostname\n"); 
		exit(ERR); 
	}
	bcopy(host->h_addr_list[0], &(alvo.sin_addr.s_addr),host->h_length);
    }
    else 
	alvo.sin_addr.s_addr= 0;
    *(unsigned long *)(pacote + 38) = alvo.sin_addr.s_addr;

    return pacote;
}



// ###################################   CREATE_INTERFACE_SOCKADDR ()     #################################

struct sockaddr_ll* create_interface_sockaddr(int ethsock, char *interface) 
{
    struct ifreq ifreq;
    static struct sockaddr_ll sll;

    memset(&sll, 0, sizeof(struct sockaddr_ll));
    strncpy(ifreq.ifr_ifrn.ifrn_name, interface, IFNAMSIZ);
    if (ioctl(ethsock, SIOCGIFINDEX, &ifreq) < 0) 
    {
        printf("Error accessing interface.\n");
        exit(ERR);
    }
    sll.sll_family = AF_PACKET;
    sll.sll_ifindex = ifreq.ifr_ifru.ifru_ivalue;
    return &sll;
}



// ###########################################   CONVERT_MAC ()   #########################################

void convert_mac(const char *p, struct mac_address *mac)
{
	int x, y, i;
	unsigned char data[6*2];
    
	for (i=0 ; i< 12; i++)
		data[i]= p[i];
	for(x=0; x < 6*2; x++) 
		if (data[x] >= 'a' && data[x] <= 'f') 
			data[x]= data[x] - 0x20;

	memset(mac, 0, sizeof(struct mac_address));
	for(x=0, y=0; x < 6*2; x+=2, y++) 
	{
	        if (data[x] >= 'A' && data[x] <= 'F') 
			mac->hardware[y] = ((data[x] - 55) * 0x10);
		else 
        	    mac->hardware[y] = ((data[x] - 0x30) * 0x10);
		if (data[x+1] >= 'A' && data[x] <= 'F') 
			mac->hardware[y] |= (data[x+1] - 55);
		else
			mac->hardware[y] |= (data[x+1] - 0x30);
	}
}



// #####################################   MODO ARP ()   ################################

int modoarp(u_char *eth, u_char *msrc, u_char *mdst, u_char *srcip, u_char *dstip) 
{
    int E, ethsock, eth2sock;
    UINT i=0, src=1, dst=1;
    UCHAR *endip;
    unsigned int tam;
    void *pacote;
    char dados[60];
    struct mac_address mac_source;
    struct mac_address mac_dest;
    struct sockaddr_in a;
    struct sockaddr_ll *sll;
    struct sockaddr_ll rr;
    unsigned short p, r;
    struct etherbyte *ether;

    ethsock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
    if ( ethsock < 0) 
    {
        printf("\nError on socket create (ethsock)\n");
	return -1;
    }
    eth2sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL));
    if ( eth2sock < 0)
    {
        printf("\nError on socket create (eth2sock)\n");
        return -1;
    }


//  ............................................  Listen Mode ARP/RARP  ......................................
    if (LE)
    {
	memset(dados, 0, 60); 
	ether= (struct etherbyte *) dados;
	tam= sizeof(struct sockaddr_ll);
	fprintf(stderr,"\nListening for ARP / RARP packets:\n");
	for (;;)
	{
		E= recvfrom(ethsock, dados, sizeof(dados), 0, (struct sockaddr *)&rr, &tam);
		if (E < 0)
		{ 
			perror("\nError: Recvfrom()...\n"); 
			return -1; 
		}
		p= htons(ether->t_proto);
		r= htons(ether->t_requi);
		if (p == (unsigned short) 0x806)
		{
		    time(&tpo);   mto= localtime(&tpo);
	 	    if (r == (unsigned short) 0x001)
		    { 
			a.sin_addr.s_addr=  ether->ip_src;
		      	printf("\n[%d] - ARP Request received: \n(%d:%d) - From Host (%s - %02x:%02x:%02x:%02x:%02x:%02x) - Asking by (%d.%d.%d.%d)\n", X++, mto->tm_hour, mto->tm_min, inet_ntoa(a.sin_addr), ether->macsrc[0], ether->macsrc[1], ether->macsrc[2], ether->macsrc[3], ether->macsrc[4], ether->macsrc[5], ether->ip_dst[0], ether->ip_dst[1], ether->ip_dst[2], ether->ip_dst[3]); 
		    }  
		    else if(r == (unsigned short) 0x0002) 
		    {
			a.sin_addr.s_addr=  ether->ip_src;
			fprintf(stderr,"\n[%d] - ARP Reply received: \n(%d:%d) - Host (%s) says it has MAC: [%02x:%02x:%02x:%02x:%02x:%02x]\n", X++, mto->tm_hour, mto->tm_min, inet_ntoa(a.sin_addr), ether->macsrc[0], ether->macsrc[1], ether->macsrc[2], ether->macsrc[3], ether->macsrc[4], ether->macsrc[5]); 
		    }
		    else 
			fprintf(stderr,"\n(%d:%d) - ARP packet UNKNOWN by MpTcp\n", mto->tm_hour, mto->tm_min);
		} 
                else if (p == (unsigned short) 0x8035)
                {
                    time(&tpo);   mto= localtime(&tpo);
                    if (r == (unsigned short) 0x003)
                    {
                        a.sin_addr.s_addr=  ether->ip_src;
                        printf("\n[%d] - RARP Request received: \n(%d:%d) - From Host [%02x:%02x:%02x:%02x:%02x:%02x] asking who is (%02x:%02x:%02x:%02x:%02x:%02x)\n", X++, mto->tm_hour, mto->tm_min, ether->macsrc[0], ether->macsrc[1], ether->macsrc[2], ether->macsrc[3], ether->macsrc[4], ether->macsrc[5], ether->mac_dst[0], ether->mac_dst[1], ether->mac_dst[2], ether->mac_dst[3], ether->mac_dst[4], ether->mac_dst[5]);
                    }
                    else if(r == (unsigned short) 0x0004)
                    {
                        a.sin_addr.s_addr=  ether->ip_src;
                        fprintf(stderr,"\n[%d] - RARP Reply received: \n(%d:%d) - Host (%s - %02x:%02x:%02x:%02x:%02x:%02x) says it has MAC [%02x:%02x:%02x:%02x:%02x:%02x] está em (%d.%d.%d.%d)\n", X++, mto->tm_hour, mto->tm_min, inet_ntoa(a.sin_addr), ether->macsrc[0], ether->macsrc[1], ether->macsrc[2], ether->macsrc[3], ether->macsrc[4], ether->macsrc[5], ether->macdst[0], ether->macdst[1], ether->macdst[2], ether->macdst[3], ether->macdst[4], ether->macdst[5], ether->ip_dst[0], ether->ip_dst[1], ether->ip_dst[2], ether->ip_dst[3]);
                    }
                    else
                        fprintf(stderr,"\n(%d:%d) - ARP packet UNKNOWN by MpTcp\n", mto->tm_hour, mto->tm_min);
                } 
	}	  
    }

//   .............................................. FIM Listen Mode ARP/RARP ......................................

//   .............................................. Mode ARPING ......................................

     if(ARPING)
     {
	cont++;
	if(!eth)
	{
	        meu_ip("eth0");
	        if (!(io)) { eth= (u_char *)"eth0"; goto KI; }
	        meu_ip("eth1");
		if (!(io)) { eth= (u_char *)"eth1"; goto KI; }
	        meu_ip("eth2");
	        if (!(io)) { eth= (u_char *)"eth2"; goto KI; }
	        meu_ip("eth3");
	        if (!(io)) { eth= (u_char *)"eth3"; goto KI; }
	        meu_ip("eth4");
	        if (!(io)) { eth= (u_char *)"eth4"; goto KI; }
	        meu_ip("eth5");
	        if (!(io)) { eth= (u_char *)"eth5"; goto KI; }
	        fprintf(stderr,"\nNo interfaces found.\nTry use -i <interface>\n");
		exit(ERR);
	}
KI:
	endip= meu_ip((char *)eth);
	if (!srcip)
		srcip= endip;
	convert_mac((char *)ETH, &mac_source);
	convert_mac((char *)"FFFFFFFFFFFF", &mac_dest);
	pacote = cria_pacote(&mac_source, &mac_dest, (char *)srcip, (char *)dstip);
	
	tam= sizeof(struct sockaddr_ll);
	ether= (struct etherbyte *) dados;
	sll= create_interface_sockaddr(ethsock, (char *)eth);
	fprintf(stderr,"ARPing to [%s]:\n\n", dstip);
	do
	{
        	E= sendto(ethsock, pacote, 80, 0, (struct sockaddr *)sll, sizeof(struct sockaddr_ll));
	        if (E < 0)
        	{
                	printf("Error: on SendTO() Ethsock\n");
	                return -1;
        	}
		do
		{
	        	E= recvfrom(eth2sock, dados, sizeof(dados), 0, (struct sockaddr *)&rr, &tam);
        	        if (E < 0)
                	{
       	                	perror("\nError: on recvfrom()...\n");
	               	        return -1;
        	        }

		} while (inet_addr((char *)dstip) != ether->ip_src);
		a.sin_addr.s_addr=  ether->ip_src;
		fprintf(stderr,"[%d] - Host (%s) [%02x:%02x:%02x:%02x:%02x:%02x] responds with %d bytes\n", X++, inet_ntoa(a.sin_addr), ether->macsrc[0], ether->macsrc[1], ether->macsrc[2], ether->macsrc[3], ether->macsrc[4], ether->macsrc[5], sizeof(dados));
	        if (DL)	
			usleep(DL);
		else if (cont) 
			sleep(1);

	} while (cont || DL);
	close (ethsock);
	free(pacote);
	return 0;
     }
//   .............................................. FIM Mode ARPING ..................................

//   .............................................. Mode MACFLOOD ....................................

     if(MACFLD)
     {
        if (!srcip)
                src--;
        if (!dstip)
                dst--;
        if(!eth)
        {
                meu_ip("eth0");
                if (!(io)) { eth= (u_char *)"eth0"; goto MF; }
                meu_ip("eth1");
                if (!(io)) { eth= (u_char *)"eth1"; goto MF; }
                meu_ip("eth2");
                if (!(io)) { eth= (u_char *)"eth2"; goto MF; }
                meu_ip("eth3");
                if (!(io)) { eth= (u_char *)"eth3"; goto MF; }
                meu_ip("eth4");
                if (!(io)) { eth= (u_char *)"eth4"; goto MF; }
                meu_ip("eth5");
                if (!(io)) { eth= (u_char *)"eth5"; goto MF; }
                fprintf(stderr,"\nNo interfaces found.\nTry use -i <interface>\n");
                exit(ERR);
        }
MF:
	sll= create_interface_sockaddr(ethsock, (char *)eth);
        tam= sizeof(struct sockaddr_ll);
        ether= (struct etherbyte *) dados;
	
        fprintf(stderr,"Shooting MacFlood with %u pacotes...", flood);
        for (i= 0; i < flood; i++)
        {
		if (!src)
                	srcip= random_ip();
		if (!dst)
			dstip= random_ip();
		random_mac();
		convert_mac((char *)ETH, &mac_dest);
		random_mac();					
		convert_mac((char *)ETH, &mac_source);
		pacote = cria_pacote(&mac_source, &mac_dest, (char *)srcip, (char *)dstip);

                E= sendto(ethsock, pacote, 80, 0, (struct sockaddr *)sll, sizeof(struct sockaddr_ll));
                if (E < 0)
                {
                        printf("Error: on SendTO() Ethsock\n");
                        return -1;
                }
		free(pacote);
        }
	fprintf(stderr,"\n\n[OK]\n");
        close (ethsock);
        return 0;
     }
//   .................................    FIM Mode MACFLOOD  ..................................

    if(!eth)
    {
                meu_ip("eth0");
                if (!(io)) { eth= (u_char *)"eth0"; goto I; }
                meu_ip("eth1");
                if (!(io)) { eth= (u_char *)"eth1"; goto I; }
                meu_ip("eth2");
                if (!(io)) { eth= (u_char *)"eth2"; goto I; }
                meu_ip("eth3");
                if (!(io)) { eth= (u_char *)"eth3"; goto I; }
                meu_ip("eth4");
                if (!(io)) { eth= (u_char *)"eth4"; goto I; }
                meu_ip("eth5");
                if (!(io)) { eth= (u_char *)"eth5"; goto I; }
                fprintf(stderr,"\nNo interfaces found.\nTry use -i <interface>\n");
                exit(ERR);
    }
I:
    if (msrc[0] == '\0')
	convert_mac((char *)ETH, &mac_source);
    else
	convert_mac((char *)msrc, &mac_source);

    if (RARP)
 	if(RQ)
	    if (!srcip)
                srcip= (u_char *) "255.255.255.255";
    
    endip= meu_ip((char *)eth);
    if (!srcip)
                srcip= endip;
    convert_mac((char *)mdst, &mac_dest);
    pacote = cria_pacote(&mac_source, &mac_dest, (char *)srcip, (char *)dstip);
    sll= create_interface_sockaddr(ethsock, (char *)eth); 

    ether= (struct etherbyte *) pacote;

    if (SP)
    {
	fprintf(stderr,"[Flooding] Sending [%s] packets to destination [%02x:%02x:%02x:%02x:%02x:%02x]\n", msg, ether->macdst[0], ether->macdst[1], ether->macdst[2], ether->macdst[3], ether->macdst[4], ether->macdst[5]);
	for (; ;)
		sendto(ethsock, pacote, 80, 0, (struct sockaddr *)sll, sizeof(struct sockaddr_ll));
    }
    do
    {
	E= sendto(ethsock, pacote, 80, 0, (struct sockaddr *)sll, sizeof(struct sockaddr_ll));  
	if (E < 0) 
	{
		printf("Error: on SendTO() Ethsock\n");
		return -1;
    	}
	time(&tpo);   mto= localtime(&tpo);
	fprintf(stderr,"[%d] - (%d:%d) Sending [%s] packet to destination [%02x:%02x:%02x:%02x:%02x:%02x]\n", X++, mto->tm_hour, mto->tm_min, msg, ether->macdst[0], ether->macdst[1], ether->macdst[2], ether->macdst[3], ether->macdst[4], ether->macdst[5]);
	if (cont)
		sleep(1);
	else if (DL) 
		usleep(DL);
    } while (cont || DL);
    close (ethsock);
    free(pacote);
    return 0;
}

