/*##############################################################################################*
*###############################################################################################*
*                                                                                               *
*                                               SOCKS.H                                         *
*                                       Header file of MpTcp                                    *
*                                                                                               *
*                                              -- ## --                                         *
*                                          Mptcp Ver: 1.6                                       *
*                                  (This file is part of MpTcp tool)                            *
*                                       Date: 10/02/2011 (14:15)                                *
*                                                                                               *
*                                                                                               *
*                       .......................................................                 *
*                                                                                               *
*                                Felipe de Oliveira - khun@hexcodes.org                         *
*                                                                                               *
*                                                                                               *
###############################################################################################*/

#ifndef SOCKS_H
#define SOCKS_H


#include <features.h>
#include <sys/uio.h>
#define	__need_size_t
#include <stddef.h>

#if defined __cplusplus || !__GNUC_PREREQ (2, 7) || !defined __USE_GNU
# define __SOCKADDR_ARG		struct sockaddr *__restrict
# define __CONST_SOCKADDR_ARG	__const struct sockaddr *
#else
# define __SOCKADDR_ALLTYPES \
  __SOCKADDR_ONETYPE (sockaddr) \
  __SOCKADDR_ONETYPE (sockaddr_at) \
  __SOCKADDR_ONETYPE (sockaddr_ax25) \
  __SOCKADDR_ONETYPE (sockaddr_dl) \
  __SOCKADDR_ONETYPE (sockaddr_eon) \
  __SOCKADDR_ONETYPE (sockaddr_in) \
  __SOCKADDR_ONETYPE (sockaddr_in6) \
  __SOCKADDR_ONETYPE (sockaddr_inarp) \
  __SOCKADDR_ONETYPE (sockaddr_ipx) \
  __SOCKADDR_ONETYPE (sockaddr_iso) \
  __SOCKADDR_ONETYPE (sockaddr_ns) \
  __SOCKADDR_ONETYPE (sockaddr_un) \
  __SOCKADDR_ONETYPE (sockaddr_x25)

# define __SOCKADDR_ONETYPE(type) struct type *__restrict __##type##__;
typedef union { __SOCKADDR_ALLTYPES
	      } __SOCKADDR_ARG __attribute__ ((__transparent_union__));
# undef __SOCKADDR_ONETYPE
# define __SOCKADDR_ONETYPE(type) __const struct type *__restrict __##type##__;
typedef union { __SOCKADDR_ALLTYPES
	      } __CONST_SOCKADDR_ARG __attribute__ ((__transparent_union__));
# undef __SOCKADDR_ONETYPE
#endif

extern int socket (int __domain, int __type, int __protocol);
extern int socketpair (int __domain, int __type, int __protocol,
		       int __fds[2]); 
extern int bind (int __fd, __CONST_SOCKADDR_ARG __addr, socklen_t __len);
extern int getsockname (int __fd, __SOCKADDR_ARG __addr,
			socklen_t *__restrict __len);
extern int connect (int __fd, __CONST_SOCKADDR_ARG __addr, socklen_t __len);
extern int getpeername (int __fd, __SOCKADDR_ARG __addr,
			socklen_t *__restrict __len);
extern ssize_t send (int __fd, __const void *__buf, size_t __n, int __flags);
extern ssize_t recv (int __fd, void *__buf, size_t __n, int __flags);
extern ssize_t sendto (int __fd, __const void *__buf, size_t __n,
		       int __flags, __CONST_SOCKADDR_ARG __addr,
		       socklen_t __addr_len);
extern ssize_t recvfrom (int __fd, void *__restrict __buf, size_t __n,
			 int __flags, __SOCKADDR_ARG __addr,
			 socklen_t *__restrict __addr_len);
extern ssize_t sendmsg (int __fd, __const struct msghdr *__message,
			int __flags);
extern ssize_t recvmsg (int __fd, struct msghdr *__message, int __flags);
extern int getsockopt (int __fd, int __level, int __optname,
		       void *__restrict __optval,
		       socklen_t *__restrict __optlen);
extern int setsockopt (int __fd, int __level, int __optname,
		       __const void *__optval, socklen_t __optlen);
extern int listen (int __fd, int __n) __THROW;
extern int accept (int __fd, __SOCKADDR_ARG __addr,
		   socklen_t *__restrict __addr_len);
extern int shutdown (int __fd, int __how);

extern char *ether_ntoa (__const struct ether_addr *__addr) __THROW;

#ifdef __USE_XOPEN2K
extern int sockatmark (int __fd);
#endif
#ifdef __USE_MISC
extern int isfdtype (int __fd, int __fdtype);
#endif
#endif //SOCKS_H ... 
