/*##############################################################################################*
*###############################################################################################*
*                                                                                               *
*                                               UTILS.H                                         *
*                                       Header file of MpTcp    	                        *
*                                                                                               *
*                                              -- ## --                                         *
*                                          Mptcp Ver: 1.6                                       *
*                                  (This file is part of MpTcp tool)                            *
*                                       Date: 28/01/2011 (19:00)                                *
*                                                                                               *
*                                                                                               *
*                       .......................................................                 *
*                                                                                               *
*                                Felipe de Oliveira - khun@hexcodes.org                         *
*                                                                                               *
*                                                                                               *
###############################################################################################*/

#ifndef UTILS_H
#define UTILS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <time.h>


#define UINT unsigned int
#define ULINT unsigned long int
#define USHORT unsigned short
#define UCHAR unsigned char
#define U8_T u_int8_t
#define ERR -1

#define T_IP   sizeof(struct iphdr)
#define T_ICMP sizeof(struct icmphdr)
#define T_UDP sizeof(struct udphdr)
#define T_TCP sizeof(struct tcphdr)
#define T_ETH sizeof(struct ether_header)

#define ICMP		1
#define TCP		6
#define UDP		17
#define ARP		99

#define F_TTL		1
#define F_DEST		2
#define F_REPLY		3
#define F_REQ		4
#define F_MASK		5
#define F_QUENCH	6

#define F_SYN 		10
#define F_ACK 		11
#define F_RST 		12
#define F_FIN 		16
#define F_PSH 		13
#define F_XMAS 		14
#define F_NULL 		15
#define F_CON		17

#define NUMCONEC 	20

#  define TH_FIN        0x01
#  define TH_SYN        0x02
#  define TH_RST        0x04
#  define TH_PUSH       0x08


struct mac_address {
    unsigned char hardware[6];
};

struct pseudo {
	        struct in_addr tetrab1;
};

struct etherbyte {
          u_int8_t macdst[6];	    	//1o ate o 5o Byte	// 6
          u_int8_t macsrc[6];	    	//6o ate o 11o byte	// 6 
	  u_int16_t t_proto;	    	//12o e 13o byte	// 2
	  u_int16_t sem_uso0;        
          u_int16_t sem_uso1;	
          u_int16_t sem_uso2;
	  u_int16_t t_requi;		//20o e 21o  byte 	// 2
          u_int8_t mac_src[6];		//22o ate 27o byte	// 6	
          u_int32_t ip_src;		//28o ate 31o byte	// 4
          u_int8_t mac_dst[6];		//32o ate 37o byte	// 6
          u_char ip_dst[4];		//38o ate 41o byte	// 4
};

#endif // UTILS_H

