/*##############################################################################################*
*###############################################################################################*
*                                                                                               *
*                                               MPTCP.C                                         *
*                                       Main Mptcp's Source file                                *
*                                                                                               *
*                                              -- ## --                                         *
*                                          MpTcp Ver: 1.6                                       *
*                                  (This file is part of MpTcp tool)                            *
*                                       Date: 10/02/2011 (16:15)                                *
*                                                                                               *
*                                                                                               *
*                       .......................................................                 *
*                                                                                               *
*                                Felipe de Oliveira - khun@hexcodes.org                         *
*                                                                                               *
*                                                                                               *
###############################################################################################*/

#include <ctype.h>
#include "include/utils.h"
#include "include/tcpip.h"


#define TTL	200


//..................................    Externas     ............................................

extern int modoicmp (UCHAR *, UCHAR *, int, UCHAR *, UCHAR *, int);
extern int modotcp (UCHAR *, UCHAR *, UCHAR *, int, int, int, int, int, int, int, int, int);
extern int modoudp (UCHAR *, UCHAR *, UCHAR *, int, int, int, int);
extern int modoarp (u_char *, u_char *, u_char *, u_char *, u_char *);




//...................................    Globais     .............................................

time_t	tpo;			// Global objects, date, hour, etc.  
struct 	tm *mto;		// ....
UINT	IX	=0;		// Flag to size of ICMP packet
UINT	SP	=0;		// Flag to Super Flood
UINT 	RQ 	=0;		// Flag to Arp reply
UINT	ARPING	=0;		// Flag to Arping
UINT	MACFLD	=0;	         // Flag to MacFlood
UINT 	MAC	=0;		// Flag to check MAC Address
UINT	RARP	=0;		// Flag to Rarp
UINT 	NI	=0;		// Flag to ICMP response (UDP)
UINT 	TL	=0;		// Flag to TTL
UINT	M	=0;		// Flag Mask
UINT 	SR	=0; 		// Flag to Address Source 
UINT 	DS	=0; 		// Flag to Destination Address
int  	DL	=0;		// Flag Delay - option -t DLY
UINT	LI	=0;		// Flag Listen ICMP
UINT	LU	=0;		// Flag Listen UDP
UINT	LT	=0;		// Flag Listen TCP
UINT	LE	=0;		// Flag Listen to packets Arp 
UINT	CON	=0;		// Flag TCP to simple connect
int 	syn	=0;		// syn flag
int	ack	=0;		// ack flag
int	fin	=0;		// fin flag
int	rst	=0;		// rst flag
UINT 	udp	=0; 		// udp flag
UINT 	cont	=0; 		// while loop counter 
int 	psh	=0; 		// push flag
int 	urg	=0; 		// urg flag
int 	null	=0; 		// Null flag
UINT 	flagport=0;		// Flag Port - Sign if port option was choice
UINT	proto	=0;		// Proto flag
UINT	X	=0;		// Global counter to lines
int	io	=0;		// Var. to ioctl error;
UINT	flood	=0;		// MacFlood packet counter



//##########################################################################################
//					MAIN ()
//##########################################################################################

int main(int argc, char *argv[])
{
    u_char *dst, *src, *pct, *net, *inface;
    UCHAR a[12], macdst[12], macsrc[12];
    char *mes, *help, *flagicmp, *flagtcp, *listen;
    int  opt, ret, port, sport, t, tipo, p, c, ttl, icmp, tcp;
    static char opcoes[] = "bcd:p:P:s:-:F:Zt:i:I:M:T:uX:l:VH:h:Aa:f:R";

     mes	= NULL;
     inface	= NULL;
     pct	= NULL;
     net	= NULL;
     t		= 0;
     tipo	= 0;
     port	= 0;
     memset(macsrc, 0, sizeof(macsrc));

S:   if (argc < 2)
      {
        fprintf(stderr,"Use:\nmptcp <OPTIONS>\n");
	fprintf(stderr,"\n\t\t\t\t<Global> Options:");
        fprintf(stderr,"\n\t-V            -->  Print Software Version");
        fprintf(stderr,"\n\t-d <Dst Host> -->  Destination Address");
	fprintf(stderr,"\n\t-s <Src Host> -->  Source Address");
        fprintf(stderr,"\n\t-p <Port>     -->  Destination Port (Remote)");
	fprintf(stderr,"\n\t-P <Src-Port> -->  Source Port (Local)");
        fprintf(stderr,"\n\t-c            -->  Continuous Mode (Delay of 1 second)");
	fprintf(stderr,"\n\t-F <Delay>    -->  Flood Mode (Delay on Microseconds)");
	fprintf(stderr,"\n\t-b            -->  Super Flood (CAUTION)");
	fprintf(stderr,"\n\t-X <BuffSize> -->  Sets packet size (Only UDP and ICMP)");
	fprintf(stderr,"\n\t-t <TTL>      -->  TTL Option");
	fprintf(stderr,"\n\t-Z            -->  Ignore replies");
	fprintf(stderr,"\n\t--help        -->  Print this screen and exit");
	fprintf(stderr,"\n\n\t\t\t\t<ICMP> Options:");
        fprintf(stderr,"\n\t-Ie           -->  ICMP packet Echo Request (Ping)");
        fprintf(stderr,"\n\t-IE           -->  ICMP packet Echo Reply");
        fprintf(stderr,"\n\t-Id           -->  ICMP packet Destination Unreachable");
        fprintf(stderr,"\n\t-It           -->  ICMP packet TTL Excedded");
        fprintf(stderr,"\n\t-Iq           -->  ICMP packet Source Quench");
	fprintf(stderr,"\n\t-Im           -->  ICMP packet Mask Request");
        fprintf(stderr,"\n\t-M <Mask>     -->  ICMP packet Mask Reply (Mask Form: -M 255.255.0.0)");
        fprintf(stderr,"\n\t-lI           -->  ICMP Listem Mode");
	fprintf(stderr,"\n\n\t\t\t\t<TCP> Options:");
	fprintf(stderr,"\n\t-Tc           -->  TCP simple connection to target");
	fprintf(stderr,"\n\t-Ts           -->  TCP SYN packet");
        fprintf(stderr,"\n\t-Ta           -->  TCP ACK packet");
        fprintf(stderr,"\n\t-Tf           -->  TCP FIN packet");
        fprintf(stderr,"\n\t-Tr           -->  TCP RST packet");
        fprintf(stderr,"\n\t-Tp           -->  TCP PUSH packet");
	fprintf(stderr,"\n\t-Tx           -->  XMAS (TCP flags FIN-PSH-URG on)");
	fprintf(stderr,"\n\t-Tn           -->  NULL (All TCP flags off)");
	fprintf(stderr,"\n\t-lT <-p Port> -->  TCP Listen Mode");	
        fprintf(stderr,"\n\n\t\t\t\t<UDP> Options:");
        fprintf(stderr,"\n\t-u            -->  UDP mode (UDP Packet)");
        fprintf(stderr,"\n\t-lU <-p Port> -->  UDP Listen Mode");
	fprintf(stderr,"\n\n\t\t\t\t<ARP / RARP> Options:");
	fprintf(stderr,"\n\t-i <Intface>  -->  Interface option. Eg: -i eth0");
	fprintf(stderr,"\n\t-H <MAC Addr> -->  Destination MAC (Form: -H xx:xx:xx:xx:xx:xx)");
	fprintf(stderr,"\n\t-h <MAC Addr> -->  Source MAC (Form: -h xx:xx:xx:xx:xx:xx)");
	fprintf(stderr,"\n\t-R            -->  RARP mode (Default as ARP)");
	fprintf(stderr,"\n\t-A            -->  Arp/Rarp REQUEST (Default as REPLY)");
	fprintf(stderr,"\n\t-a <Dest IP>  -->  Arp'ing (Ping ARP mode and Bypass the ICMP filter)");
	fprintf(stderr,"\n\t-f <Num Pac>  -->  Mac Flooding - Massive Flood of ARP packets (CAUTION)");
	fprintf(stderr,"\n\t-lE           -->  ARP/RARP Listen Mode\n\n");
	return(1); 
      }
    if (getuid() != 0)    
    {                  
      fprintf(stderr,"\nUID non equal to (0) Zero (root login ? - root Login required).\n");
      exit(ERR);
    }
    time(&tpo);  
    ttl= TTL;    
    mto= localtime(&tpo);
    switch(mto->tm_mon)
    {   
	case 0: {mes= "Jan"; break; }
	case 1: {mes= "Feb"; break; }
	case 2: {mes= "Mar"; break; }
	case 3: {mes= "Apr"; break; }
	case 4: {mes= "May"; break; }
	case 5: {mes= "Jun"; break; }
        case 6: {mes= "Jul"; break; }
	case 7: {mes= "Aug"; break; }
	case 8: {mes= "Sep"; break; }
	case 9: {mes= "Octo"; break; }
	case 10: {mes= "Nov"; break; }
	case 11: {mes= "Dec"; break; }
    }
    fprintf(stderr,"\n                        Starting MpTcp 1.6 at [%02d.%s.%02d - %02d:%02d]\n", mto->tm_mday, \
					mes, (mto->tm_year+1900), mto->tm_hour, mto->tm_min);
    fprintf(stderr,"                             -MpTcp Project (www.hexcodes.org)-\n\n");
    src= NULL;
    dst= NULL;
    sport= 0;
    srand(time(NULL));
    while((opt = getopt(argc,argv,opcoes)) != -1)
         switch(opt)
            {
              case 'c':
              {
                cont++;
                break;
              }
              case 'b':
              {
                SP++;
                break;
              }
              case 'd':
              {
                dst= (unsigned char *)optarg;
                DS++;
		break;
	      }
	      case 'F':
	      {
		
		DL= atoi(optarg);
	        if (DL < 1)
		{
			fprintf(stderr,"Invalid Flood delay\n\n");
			exit(ERR); 
		}
		break;
	      }
	      case 't':
	      {
			ttl= atoi(optarg);
			if((ttl < 1) || (ttl > 255))
			{
				fprintf(stderr,"\nError. Set TTL value between 1~255\n");
		     		exit(ERR); 
			}
			TL++;
		break;	      
	      }
	      case '-':
	      {
		help= (char *) optarg;
                if (strcmp("help", help))
		{
			fprintf(stderr,"\nIncorrect --%s argument\n", help); 
			exit(ERR);
		} 
		argc= 0;
		goto S;
	      }
	      case 's':
              {                 
                src= (unsigned char *) optarg;
                SR++;
		break;
              }
	      case 'I':
	      {
		proto= ICMP;
		flagicmp= (char *) optarg;
		if (!strcmp(flagicmp, "t"))
		     icmp= F_TTL;
		else if (!strcmp(flagicmp, "d"))
			icmp= F_DEST;
		else if (!strcmp(flagicmp, "e"))
		        icmp= F_REQ;
		else if (!strcmp(flagicmp, "E"))
		       icmp= F_REPLY;
	        else if (!strcmp(flagicmp, "m"))
	                  icmp= F_MASK;
		else if (!strcmp(flagicmp, "q"))
			  icmp= F_QUENCH;
		else 
		{ 
			fprintf(stderr,"\nInvalid ICMP option\n"); 
			exit(ERR);
		}
		switch (icmp) 
			{
				case F_TTL:
              			{
                			pct= (unsigned char *) "TTL Excedded";
                			tipo= 0x0B;
                			break;
              			}
              			case F_DEST:
              			{
                			pct=(unsigned char *) "Destination Unreachable";
                			tipo= 0x03;
					break;
              			}
              			case F_REQ:
              			{
                			pct= (unsigned char *) "Echo Request";
                			tipo= 0x08;
                			break;                 
              				}
              			case F_REPLY:
              			{
                			pct= (unsigned char *) "Echo Reply";
                			tipo= 0x00;
                			break;
              			}
				case F_QUENCH:
				{
					pct= (unsigned char *) "Source Quench";
					tipo= 0x04;
					break;
				}
				case F_MASK:
           	  		{
                			pct= (unsigned char *) "Mask Request";
                			tipo= 0x11;
                			break;
              			}
			}
			break;
	      }	
              case 'M':
              {
		pct= (unsigned char *) "Mask Reply";
		net= (unsigned char *) optarg;
		M++;
		proto= ICMP;
		tipo= 0x12;
		break;
	       }
              case 'p':
              {
		port= atoi(optarg);
                if((port < 0) || (port > 65535)) 
		{
        	        fprintf(stderr,"\nInvalid Port. Set the correct -p <port>.\n"); 
			exit(ERR); 
		}
                flagport++;
                break;
              }
              case 'P':
	      {
	          sport= atoi(optarg);
	          if((sport < 0) || (sport > 65535)) 
		  {
	          	fprintf(stderr,"\nInvalid Local Port. Set the correct -P <port>.\n"); 
			exit(ERR); 
		  }
		  break;
	      }
	      case 'T':
	      {
		proto= TCP;
		flagtcp= (char *) optarg;
		if (!strcmp(flagtcp, "s"))
		     tcp= F_SYN;
                else if (!strcmp(flagtcp, "c"))
                     tcp= F_CON;
		else if (!strcmp(flagtcp, "a"))
		     tcp= F_ACK;
		else if (!strcmp(flagtcp, "f"))
		     tcp= F_FIN;
		else if (!strcmp(flagtcp, "r"))
		      tcp= F_RST;
		else if (!strcmp(flagtcp, "p"))
		      tcp= F_PSH;
		else if (!strcmp(flagtcp, "x"))
		      tcp= F_XMAS;
		else if (!strcmp(flagtcp, "n"))
			tcp= F_NULL;
		else 
		{ 
			fprintf(stderr,"\nInvalid TCP option\n"); 
			exit(ERR);
		}
		switch (tcp)
		{
                     case F_CON:
                        {
                        pct= (unsigned char *) "TCP Connection packet";
                        CON++;
                        break;
                        }
		     case F_SYN:
	             	{
          	      	pct= (unsigned char *) "TCP SYN";
                	syn++;
                	break;
              		}
		      case F_ACK:
              		{
                	pct= (unsigned char *) "TCP ACK";
                	ack++;
                	break;
              		}
              	      case F_FIN:
              		{
                	pct= (unsigned char *) "TCP FIN";
                	fin++;
                	break;
              		}
              	      case F_RST:
              		{
                	pct= (unsigned char *) "TCP RST";
                	rst++;
                	break;
              		}
	      	      case F_PSH:
	      		{
	        	pct= (unsigned char *) "TCP PUSH";
			psh++;
			break;
	      		}
	      	      case F_XMAS:
	      		{
		      	pct= (unsigned char *) "TCP XMAS";
		      	fin++;
		      	psh++;
		      	urg++;
		      	break;
	      		}
	      	      case F_NULL:
	      		{
		      	pct= (unsigned char *) "TCP NULL (No Flags)";
		      	null++;
		      	break;
	      		}
		 }
		 break;
	      } 
	      case 'l':
	      		{
				listen= (char *) optarg;
				if (!strcmp(listen, "T"))
				   	proto= TCP;
				else if (!strcmp(listen, "U"))
					proto= UDP;
				else if (!strcmp(listen, "E"))
					proto= ARP;
				else if (!strcmp(listen, "I"))
					proto= ICMP;
				else 
				{ 
					fprintf(stderr,"\nInvalid Listem mode\n"); 
					exit(ERR);
				}
		switch(proto)
		{
			case ICMP:
			{
			   LI++;
			   tipo= 0xFF;
			   pct= (unsigned char *) "Listening for ICMP data:";
			   DS++;
			   break;
			}
			case TCP:
			{
				LT++;
				DS++;
				break;
			}	
			case UDP:
			{			
				LU++;	
				t= 0;
				DS++;
				break;
			}
			case ARP:
			{
				LE++;
				MAC += 3;
				DS++;
				dst= NULL;
				src= NULL;
				inface= (unsigned char *) "eth0";
				break;
			}
		}
		break;  
	      }
	      case 'u':
              {
		pct= (unsigned char *) "UDP";
		udp++;
                proto= UDP;
                break;
              }
	      case 'Z':
	      {
		NI++;
		break;
	      }
	      case 'X':
	      {
		t= atoi(optarg);
		IX= t;
		break;	
	      }
              case 'R':
              {
		proto= ARP;
                RARP++;
                break;
              }	      
	      case 'h':
	      {
	      	proto= ARP;
		MAC++;
		DS++;
                p= sscanf(optarg, "%c%c:%c%c:%c%c:%c%c:%c%c:%c%c", 
		                &a[0],&a[1],
		                &a[2],&a[3],     
		                &a[4],&a[5],
		                &a[6],&a[7],
		                &a[8],&a[9],
		                &a[10],&a[11]);
		if (p != 12)
		{ 
			fprintf(stderr,"\nError: Invalid MAC ADDRESS\n");
		        exit(ERR); 
		}
		for (c = 0; c < 12; c++)
		{
			if (tolower(a[c]) > 'f') 
			{ 
				fprintf(stderr,"\nError: Invalid MAC ADDRESS - Character [%c] invalid\n", a[c]); 
				exit(ERR);
			}
		        macsrc[c]= a[c];
		}
		break;
	      }
	      case 'H':
	      {
	            proto= ARP;
		    MAC += 3;
		    DS++;
		    p= sscanf(optarg, "%c%c:%c%c:%c%c:%c%c:%c%c:%c%c",
	                     &a[0],&a[1],
	                     &a[2],&a[3],
	                     &a[4],&a[5],   
	                     &a[6],&a[7],
	                     &a[8],&a[9],
	                     &a[10],&a[11]);
                    if (p != 12)
                    { 
			fprintf(stderr,"\nError - Invalid MAC ADDRESS\n");
                        exit(ERR); 
		    }
                    for (c = 0; c < 12; c++)
		    {
			if (tolower(a[c]) > 'f')
			{ 
				fprintf(stderr,"\nError: Invalid MAC ADDRESS - Character [%c] invalid\n", a[c]); 
				exit(ERR);
			}
		        macdst[c]= a[c];
		    }
		    break;
              }
	      case 'i':
	      {
		      proto= ARP;
	      	      inface= (unsigned char *) optarg;
		      DS++;
		      MAC++;
		      break;
	      }
	      case 'A':
	      {
	      		proto= ARP;
		      	RQ++;
		     	break;
	      }
              case 'a':
              {
			dst= (unsigned char *)optarg;
			DS++;
                        proto= ARP;
			RQ++;
                        ARPING++;
                        break;
              }
              case 'f':
              {
	                  flood= atoi(optarg);
                	  if((flood < 1) || (flood > 1000000000UL))
        	          {
	                        fprintf(stderr,"\nInvalid number packets. Use a value between 1~1.000.000.000\n");
                        	exit(ERR);
                  	}
                        DS++;
                        proto= ARP;
			MACFLD++;
                        break;
              }
	      case 'V':
              {
                DS++;
		fprintf(stderr,"\n\n\n                               - MpTcp - TCP/IP MultiPackets -");
		fprintf(stderr,"\n\n            Ver: 1.6 - Released under GPL/GNU (Build Date: 10.02.2011 - 16:15).");
                fprintf(stderr,"\n            Final Version: Statically and dynamically compiled without dependences. ");
		fprintf(stderr,"\n            More includes that were used on compilation are available here too.");
		fprintf(stderr,"\n\n                     Questions or BUGs please Mail me: khun@hexcodes.org");
		fprintf(stderr,"\n\n\n\n");
		break;
              }
              default:
              {
                fprintf(stderr,"Invalid Option!\n");
                exit(ERR);
              }
	    }
    if (!DS) 
    { 
	fprintf(stderr,"\nNeed to tell -d <Destination>\n"); 
	exit(ERR);
    }
//-------------------------------------------------------------------------------

    if (cont && DL) 
    { 
	fprintf(stderr,"\nUse Continue or Flood Delay at once.\n"); 
	exit(ERR); 
    }
    if (cont && SP) 
    { 
	fprintf(stderr,"\nUse Continue ou Super Flood at once.\n"); 
	exit(ERR); 
    }
    if (DL && SP) 
    { 
	fprintf(stderr,"\nUse Flood Delay ou Super Flood at once.\n"); 
	exit(ERR); 
    }
//-------------------------------------------------------------------------------

    if ((LT) && (proto != TCP))
    { 
	fprintf(stderr,"\nUse -lT option only for TCP mode.\n"); 
	exit(ERR); 
    }
    if ((LE) && (proto != ARP))
    {
	fprintf(stderr,"\nUse -lE option only form ARP mode.\n"); 
	exit(ERR);
    }
    if ((LU) && (proto != UDP))
    {
	fprintf(stderr,"\nUse -lU option only for UDP mode.\n"); 
	exit(ERR);
    }
    if ((LI) && (proto != ICMP))
    {
	fprintf(stderr,"\nUse -lI option only for ICMP mode.\n"); 
	exit(ERR);
    }
//-------------------------------------------------------------------------------

    if ( (udp) && ((t < 0) || (t > 1024)) )
    {
	fprintf(stderr,"\nInvalid UDP packet size (MAX: 1024 bytes).\n"); 
	exit(ERR);
    }
    if ( (t) && ((proto == TCP) || (proto == ARP)) )
    {
	fprintf(stderr,"\nUse -X option only to UDP or ICMP .\n"); 
	exit(ERR);
    }
    if ( ((proto == UDP) || (proto == TCP)) && !flagport)
    { 
	fprintf(stderr,"Error: TCP and UDP packets need to tell <porta>\n\n"); 
	exit(ERR); 
    }
//-------------------------------------------------------------------------------

    if ( (proto == TCP) && (udp) )
    { 
	fprintf(stderr,"\nUse TCP flags without UDP mode.\n");
	exit(ERR); 
    } 
//-------------------------------------------------------------------------------

    if (((proto == ICMP) || (proto == ARP)) && (flagport || sport))
    { 
	fprintf(stderr,"Error: ICMP and ARP packets don't need to tell <port>  \nNoob ?? :)..\n\n"); 
	exit(ERR); 
    }
//-------------------------------------------------------------------------------

    if ((ARPING) && (proto != ARP))
    {
        fprintf(stderr,"\nUse -a option (Arp'ing) only for ARP mode.\n");
        exit(ERR);
    }
    if ((MACFLD) && (proto != ARP))
    {
        fprintf(stderr,"\nUse -f option (Mac Flooding) only for ARP mode.\n");
        exit(ERR);
    }
    if ( (!ARPING) && (!MACFLD) &&  (MAC) && (MAC < 3) )
    { 
	fprintf(stderr,"\nError: ARP/RARP packets that aren't ARPING or aren`t MAC FLOOD modes NEED to tell -H <DESTINATION MAC>\n\n"); 
	exit(ERR); 
    } 
    if ((proto == ARP) && TL)
    {
        fprintf(stderr,"\nError: ARP packet don't need to tell TTL.\n");
        exit(ERR);
    }
    if ( (RARP) && (MACFLD || ARPING) )
    {
	fprintf(stderr,"RARP Error: Use ARPING or MAC FLOOD only for ARP mode.\n\n"); 
	exit(ERR); 
    }

    switch (proto)
    {
	case ARP:
	{    
		if ((ret= modoarp(inface, macsrc , macdst, src, dst)))
		    {
		        fprintf(stderr,"Error on ARP data !!\n");
			exit(ERR);
		    }
		break;
	}    
	case ICMP:
	{
		if ((ret= modoicmp(src, dst, tipo, net, pct, ttl)))
		{ 
			fprintf(stderr,"Error on ICMP data !!\n"); 
			exit(ERR); 
		}
            break;
	}
        case TCP:  
	{ 
	    if (LT) dst= NULL;
	    if ((ret= modotcp(src, dst, pct, port, sport, syn, ack, fin, rst, psh, urg, ttl)))
	     {	
		fprintf(stderr,"Error on TCP data !!"); 
		exit (ERR); 
	      }
	    break;
	 }
         case UDP:  
	 { 
	     if (LU) dst = NULL;
	     if ((ret= modoudp(src, dst, pct, port, sport, t, ttl)))
                   {
			fprintf(stderr,"Error on UDP data !!");
			exit (ERR);
		   }
	     break;	
	 }	
    }
    return 0;
}

